module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 4);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("ru-toolkit-mathematics");

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;
exports.errConfig = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.scaling = scaling;
exports.timestamp = timestamp;
exports.sort = sort;
exports.base64ToTempFilePath = base64ToTempFilePath;
exports.triangle = triangle;
exports.createImage = createImage;
exports.maximumSizeOfCanvas = maximumSizeOfCanvas;

var _ruToolkitMathematics = __webpack_require__(0);

var errConfig = exports.errConfig = {
    NotAllowTriangle: { errCode: 1001, errMsg: "不允许三角形裁切" }
};
/**
 * 缩放
 * @param ow 源图宽
 * @param oh 源图高
 * @param tw 目标宽
 * @param th 目标高
 */
function scaling(ow, oh, tw, th) {
    var s = 0;
    if (ow > oh) {
        s = ow / oh;
        ow = tw;
        oh = ow / s;
    } else {
        s = ow / oh;
        oh = th;
        ow = oh * s;
    }
    if (th < oh) {
        s = ow / oh;
        oh = th;
        ow = oh * s;
    }
    if (tw < ow) {
        s = ow / oh;
        ow = tw;
        oh = ow / s;
    }
    return { ow: ow, oh: oh };
}
/**
 * 获取时间戳
 */
function timestamp() {
    return new Date().getTime();
}
/**
 * 点排序
 * @param points
 */
function sort(points) {
    var a = points[0];
    var b = points[1];
    var c = points[2];
    var d = points[3];
    if (_ruToolkitMathematics.Vector2.checkCross(a, b, c, d)) {
        b = points[2];
        c = points[1];
    } else if (_ruToolkitMathematics.Vector2.checkCross(a, d, c, b)) {
        a = points[1];
        b = points[0];
    }
    return [a, b, c, d];
}
/**
 * 获取临时图片
 * @param base64
 * @returns
 */
function base64ToTempFilePath(base64) {
    return new Promise(function (resolve, reject) {
        var fs = wx.getFileSystemManager();
        var times = new Date().getTime();
        var tempFilePath = wx.env.USER_DATA_PATH + '/' + times + '.png';
        fs.writeFile({
            filePath: tempFilePath,
            data: base64.split(',')[1],
            encoding: 'base64',
            success: function success(res) {
                resolve(tempFilePath);
            },
            fail: function fail(err) {
                reject(err);
            }
        });
    });
}
/** 三角形 */
function triangle(points) {
    var _loop = function _loop(i) {
        var curr = points[i];
        var other = points.filter(function (p, j) {
            return i != j;
        });
        if (_ruToolkitMathematics.Vector2.checkInTriangle(curr, other[0], other[1], other[2])) {
            return {
                v: other
            };
        }
    };

    for (var i = 0; i < points.length; i++) {
        var _ret = _loop(i);

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    }
    return [];
}
/** 获取图片 */
function createImage(canvas, src) {
    return new Promise(function (resolve, reject) {
        var img = canvas.createImage();
        img.src = src;
        img.onload = function () {
            resolve(img);
        };
    });
}
/**
 * canvas最大尺寸
 * @param {HTMLCanvasElement} canvas
 * @param {number} width
 * @param {number} height
 * @param {number} dpr
 */
function maximumSizeOfCanvas(canvas, width, height, dpr) {
    var scale = 0;
    var targetWidth = 4096;
    var targetHeight = 4096;
    var currWidth = width;
    var currHeight = height;
    width *= dpr;
    height *= dpr;
    if (width < targetWidth && height < targetHeight) {
        canvas.width = width;
        canvas.height = height;
        return { width: width, height: height, dpr: dpr, canvas: canvas };
    }
    if (width > height) {
        scale = width / height;
        width = targetWidth;
        height = width / scale;
    } else {
        scale = width / height;
        height = targetHeight;
        width = height * scale;
    }
    if (targetHeight < height) {
        scale = width / height;
        height = targetHeight;
        width = height * scale;
    }
    if (targetWidth < width) {
        scale = width / height;
        width = targetWidth;
        height = width / scale;
    }
    canvas.width = width;
    canvas.height = height;
    return { width: width, height: height, canvas: canvas, dpr: width / currWidth };
}

/***/ }),
/* 2 */,
/* 3 */,
/* 4 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


var _ruToolkitMathematics = __webpack_require__(0);

var _utils = __webpack_require__(1);

var __awaiter = undefined && undefined.__awaiter || function (thisArg, _arguments, P, generator) {
    function adopt(value) {
        return value instanceof P ? value : new P(function (resolve) {
            resolve(value);
        });
    }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) {
            try {
                step(generator.next(value));
            } catch (e) {
                reject(e);
            }
        }
        function rejected(value) {
            try {
                step(generator["throw"](value));
            } catch (e) {
                reject(e);
            }
        }
        function step(result) {
            result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected);
        }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};

/** 默认值 */
var defaultConfig = {
    allowTriangle: false,
    renderInterval: 20,
    color: "#B4CF66",
    errColor: "#FF5A33",
    point: {
        raduis: 10
    },
    line: {
        width: 2
    },
    definition: 1
};
/**
 * @Author 林一怂儿
 * @Date 2022/05/03 02:58:01
 */
Component({
    properties: {
        /** 图片地址 */
        src: String,
        /** 配置 */
        config: Object
    },
    data: {
        points: [],
        pointRaduis: 0,
        pointColor: "",
        pointErrColor: "",
        lineWidth: 0,
        lineColor: "",
        lineErrColor: "",
        renderInterval: 0,
        allowTriangle: false,
        operateCanvas: null,
        operateContext: null,
        operateWidth: 0,
        operateHeight: 0,
        boxWidth: 0,
        boxHeight: 0,
        image: null,
        imageX: 0,
        imageY: 0,
        imageWidth: 0,
        imageHeight: 0,
        clipCanvas: null,
        clipContext: null,
        moveingIndex: -1,
        lastRenderTime: 0,
        imageAngle: 0,
        clipDpr: 1
    },
    lifetimes: {
        ready: function ready() {
            var _this = this;

            var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o, _p, _q, _r, _s, _t, _u;
            /** 获取配置 */
            var config = this.properties.config;
            /** 操作点的半径、颜色、错误颜色 */
            var pointRaduis = (_b = (_a = config === null || config === void 0 ? void 0 : config.point) === null || _a === void 0 ? void 0 : _a.raduis) !== null && _b !== void 0 ? _b : defaultConfig.point.raduis;
            var pointColor = (_e = (_d = (_c = config === null || config === void 0 ? void 0 : config.point) === null || _c === void 0 ? void 0 : _c.color) !== null && _d !== void 0 ? _d : config === null || config === void 0 ? void 0 : config.color) !== null && _e !== void 0 ? _e : defaultConfig.color;
            var pointErrColor = (_h = (_g = (_f = config === null || config === void 0 ? void 0 : config.point) === null || _f === void 0 ? void 0 : _f.errColor) !== null && _g !== void 0 ? _g : config === null || config === void 0 ? void 0 : config.errColor) !== null && _h !== void 0 ? _h : defaultConfig.errColor;
            /** 操作线的宽度、颜色、错误颜色 */
            var lineWidth = (_k = (_j = config === null || config === void 0 ? void 0 : config.line) === null || _j === void 0 ? void 0 : _j.width) !== null && _k !== void 0 ? _k : defaultConfig.line.width;
            var lineColor = (_o = (_m = (_l = config === null || config === void 0 ? void 0 : config.point) === null || _l === void 0 ? void 0 : _l.color) !== null && _m !== void 0 ? _m : config === null || config === void 0 ? void 0 : config.color) !== null && _o !== void 0 ? _o : defaultConfig.color;
            var lineErrColor = (_r = (_q = (_p = config === null || config === void 0 ? void 0 : config.line) === null || _p === void 0 ? void 0 : _p.errColor) !== null && _q !== void 0 ? _q : config === null || config === void 0 ? void 0 : config.errColor) !== null && _r !== void 0 ? _r : defaultConfig.errColor;
            /** 渲染间隔 */
            var renderInterval = (_s = config === null || config === void 0 ? void 0 : config.renderInterval) !== null && _s !== void 0 ? _s : defaultConfig.renderInterval;
            /** 是否允许三角形 */
            var allowTriangle = (_t = config === null || config === void 0 ? void 0 : config.allowTriangle) !== null && _t !== void 0 ? _t : defaultConfig.allowTriangle;
            var definition = (_u = config === null || config === void 0 ? void 0 : config.definition) !== null && _u !== void 0 ? _u : defaultConfig.definition;
            var dpr = wx.getSystemInfoSync().pixelRatio;
            var q = this.createSelectorQuery();
            q.select('#clip').fields({ node: true, size: true });
            q.select("#operate").fields({ node: true, size: true });
            q.exec(function (res) {
                return __awaiter(_this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee() {
                    var operateCanvas, operateContext, operateWidth, operateHeight, boxWidth, boxHeight, maximumSize, clipCanvas, clipContext;
                    return regeneratorRuntime.wrap(function _callee$(_context) {
                        while (1) {
                            switch (_context.prev = _context.next) {
                                case 0:
                                    operateCanvas = res[1].node;
                                    operateContext = operateCanvas.getContext('2d');
                                    operateWidth = res[1].width;
                                    operateHeight = res[1].height;
                                    boxWidth = operateWidth - pointRaduis * 2;
                                    boxHeight = operateHeight - pointRaduis * 2;
                                    maximumSize = (0, _utils.maximumSizeOfCanvas)(operateCanvas, operateWidth, operateHeight, dpr);

                                    operateContext.scale(maximumSize.dpr, maximumSize.dpr);
                                    clipCanvas = res[0].node;
                                    clipContext = clipCanvas.getContext('2d');
                                    // clipContext.scale(dpr, dpr);

                                    this.data.operateCanvas = operateCanvas;
                                    this.data.operateContext = operateContext;
                                    this.data.operateWidth = operateWidth;
                                    this.data.operateHeight = operateHeight;
                                    this.data.boxWidth = boxWidth;
                                    this.data.boxHeight = boxHeight;
                                    this.data.clipCanvas = clipCanvas;
                                    this.data.clipContext = clipContext;
                                    this.data.pointColor = pointColor;
                                    this.data.pointErrColor = pointErrColor;
                                    this.data.pointRaduis = pointRaduis;
                                    this.data.lineColor = lineColor;
                                    this.data.lineErrColor = lineErrColor;
                                    this.data.lineWidth = lineWidth;
                                    this.data.renderInterval = renderInterval;
                                    this.data.allowTriangle = allowTriangle;
                                    _context.next = 28;
                                    return this.imageChange(this.properties.src);

                                case 28:
                                    this.reset();
                                    this.render();

                                case 30:
                                case 'end':
                                    return _context.stop();
                            }
                        }
                    }, _callee, this);
                }));
            });
        }
    },
    methods: {
        imageChange: function imageChange(src) {
            var _a, _b;
            return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee2() {
                var dpr, _data, operateCanvas, operateContext, operateWidth, operateHeight, clipContext, image, imageX, imageY, imageWidth, imageHeight, lineColor, lineErrColor, lineWidth, pointRaduis, pointColor, pointErrColor, points, boxWidth, boxHeight, clipCanvas, definition, _scaling, ow, oh, maximumSize;

                return regeneratorRuntime.wrap(function _callee2$(_context2) {
                    while (1) {
                        switch (_context2.prev = _context2.next) {
                            case 0:
                                dpr = wx.getSystemInfoSync().pixelRatio;
                                _data = this.data, operateCanvas = _data.operateCanvas, operateContext = _data.operateContext, operateWidth = _data.operateWidth, operateHeight = _data.operateHeight, clipContext = _data.clipContext, image = _data.image, imageX = _data.imageX, imageY = _data.imageY, imageWidth = _data.imageWidth, imageHeight = _data.imageHeight, lineColor = _data.lineColor, lineErrColor = _data.lineErrColor, lineWidth = _data.lineWidth, pointRaduis = _data.pointRaduis, pointColor = _data.pointColor, pointErrColor = _data.pointErrColor, points = _data.points, boxWidth = _data.boxWidth, boxHeight = _data.boxHeight, clipCanvas = _data.clipCanvas;
                                definition = (_b = (_a = this.properties.config) === null || _a === void 0 ? void 0 : _a.definition) !== null && _b !== void 0 ? _b : defaultConfig.definition;
                                _context2.next = 5;
                                return (0, _utils.createImage)(operateCanvas, src);

                            case 5:
                                image = _context2.sent;
                                _scaling = (0, _utils.scaling)(+image.width, +image.height, boxWidth, boxHeight), ow = _scaling.ow, oh = _scaling.oh;

                                imageWidth = ow;
                                imageHeight = oh;
                                imageX = (boxWidth - imageWidth) / 2 + pointRaduis;
                                imageY = (boxHeight - imageHeight) / 2 + pointRaduis;
                                maximumSize = (0, _utils.maximumSizeOfCanvas)(clipCanvas, operateWidth, operateHeight, dpr * definition);

                                clipContext.scale(maximumSize.dpr, maximumSize.dpr);
                                this.data.clipDpr = maximumSize.dpr;
                                this.data.image = image;
                                this.data.imageWidth = imageWidth;
                                this.data.imageHeight = imageHeight;
                                this.data.imageX = imageX;
                                this.data.imageY = imageY;

                            case 19:
                            case 'end':
                                return _context2.stop();
                        }
                    }
                }, _callee2, this);
            }));
        },
        render: function render() {
            var _data2 = this.data,
                operateContext = _data2.operateContext,
                operateWidth = _data2.operateWidth,
                operateHeight = _data2.operateHeight,
                image = _data2.image,
                imageX = _data2.imageX,
                imageY = _data2.imageY,
                imageWidth = _data2.imageWidth,
                imageHeight = _data2.imageHeight,
                lineColor = _data2.lineColor,
                lineErrColor = _data2.lineErrColor,
                lineWidth = _data2.lineWidth,
                pointRaduis = _data2.pointRaduis,
                pointColor = _data2.pointColor,
                pointErrColor = _data2.pointErrColor,
                points = _data2.points;
            // 清空画布

            operateContext.clearRect(0, 0, operateWidth, operateHeight);
            operateContext.drawImage(image, imageX, imageY, imageWidth, imageHeight);
            operateContext.beginPath();
            operateContext.strokeStyle = lineColor;
            operateContext.lineWidth = lineWidth;
            operateContext.fillStyle = pointColor;
            // 三角行的点
            var trianglePoints = (0, _utils.triangle)(points);
            // 检查是否存在
            if (trianglePoints.length > 0) {
                operateContext.strokeStyle = lineErrColor;
                operateContext.fillStyle = pointErrColor;
                for (var i = 0; i < trianglePoints.length; i++) {
                    var tmp = trianglePoints[i];
                    i == 0 ? operateContext.moveTo(tmp.x, tmp.y) : operateContext.lineTo(tmp.x, tmp.y);
                }
            } else {
                points = (0, _utils.sort)(points);
                for (var _i = 0; _i < points.length; _i++) {
                    var _tmp = points[_i];
                    _i == 0 ? operateContext.moveTo(_tmp.x, _tmp.y) : operateContext.lineTo(_tmp.x, _tmp.y);
                }
            }
            operateContext.closePath();
            operateContext.stroke();
            // 点
            for (var _i2 = 0; _i2 < points.length; _i2++) {
                operateContext.lineWidth = 1;
                var _tmp2 = points[_i2];
                operateContext.beginPath();
                operateContext.arc(_tmp2.x, _tmp2.y, pointRaduis - 1, 0, 2 * Math.PI);
                operateContext.stroke();
                operateContext.fill();
            }
            this.data.point = points;
        },
        touchstart: function touchstart(e) {
            var _data3 = this.data,
                points = _data3.points,
                pointRaduis = _data3.pointRaduis;
            var _e$changedTouches$ = e.changedTouches[0],
                x = _e$changedTouches$.x,
                y = _e$changedTouches$.y;

            this.data.moveingIndex = points.findIndex(function (p) {
                return Math.abs(p.x - x) < pointRaduis && Math.abs(p.y - y) < pointRaduis;
            });
            this.render();
        },
        touchmove: function touchmove(e) {
            var _data4 = this.data,
                moveingIndex = _data4.moveingIndex,
                renderInterval = _data4.renderInterval,
                points = _data4.points,
                imageX = _data4.imageX,
                imageY = _data4.imageY,
                imageWidth = _data4.imageWidth,
                imageHeight = _data4.imageHeight,
                lastRenderTime = _data4.lastRenderTime;

            if (moveingIndex == -1) return;
            if ((0, _utils.timestamp)() - lastRenderTime < renderInterval) return;
            this.data.lastRenderTime = (0, _utils.timestamp)();
            var _e$changedTouches$2 = e.changedTouches[0],
                x = _e$changedTouches$2.x,
                y = _e$changedTouches$2.y;

            if (imageX > x) points[moveingIndex].x = imageX;else if (x > imageX + imageWidth) points[moveingIndex].x = imageX + imageWidth;else points[moveingIndex].x = x;
            if (imageY > y) points[moveingIndex].y = imageY;else if (y > imageY + imageHeight) points[moveingIndex].y = imageY + imageHeight;else points[moveingIndex].y = y;
            this.render();
        },

        /** 裁切 */
        clip: function clip() {
            return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee3() {
                var _data5, image, imageX, imageY, imageWidth, imageHeight, clipCanvas, clipContext, points, pointRaduis, allowTriangle, operateWidth, operateHeight, clipDpr, dpr, trianglePoints, i, tmp, offsetMinX, offsetMinY, offsetMaxX, offsetMaxY, _i3, offsetWidth, offsetHeight, base64;

                return regeneratorRuntime.wrap(function _callee3$(_context3) {
                    while (1) {
                        switch (_context3.prev = _context3.next) {
                            case 0:
                                _data5 = this.data, image = _data5.image, imageX = _data5.imageX, imageY = _data5.imageY, imageWidth = _data5.imageWidth, imageHeight = _data5.imageHeight, clipCanvas = _data5.clipCanvas, clipContext = _data5.clipContext, points = _data5.points, pointRaduis = _data5.pointRaduis, allowTriangle = _data5.allowTriangle, operateWidth = _data5.operateWidth, operateHeight = _data5.operateHeight, clipDpr = _data5.clipDpr;
                                dpr = wx.getSystemInfoSync().pixelRatio;

                                points = (0, _utils.sort)(points);
                                // 三角形
                                trianglePoints = (0, _utils.triangle)(points);

                                if (!(allowTriangle && trianglePoints.length > 0)) {
                                    _context3.next = 8;
                                    break;
                                }

                                points = trianglePoints;
                                _context3.next = 10;
                                break;

                            case 8:
                                if (!(!allowTriangle && trianglePoints.length > 0)) {
                                    _context3.next = 10;
                                    break;
                                }

                                throw _utils.errConfig.NotAllowTriangle;

                            case 10:
                                clipContext.restore();
                                clipContext.clearRect(0, 0, operateWidth, operateHeight);
                                clipContext.save();
                                clipContext.beginPath();
                                clipContext.lineWidth = 0;
                                for (i = 0; i < points.length; i++) {
                                    tmp = points[i];

                                    i == 0 ? clipContext.moveTo(tmp.x - imageX, tmp.y - imageY) : clipContext.lineTo(tmp.x - imageX, tmp.y - imageY);
                                }
                                clipContext.closePath();
                                clipContext.clip();
                                clipContext.drawImage(image, 0, 0, imageWidth, imageHeight);
                                /** 偏移量 */
                                offsetMinX = 9999;
                                offsetMinY = 9999;
                                offsetMaxX = -9999;
                                offsetMaxY = -9999;

                                for (_i3 = 0; _i3 < points.length; _i3++) {
                                    if (points[_i3].x < offsetMinX) offsetMinX = points[_i3].x;
                                    if (points[_i3].y < offsetMinY) offsetMinY = points[_i3].y;
                                    if (points[_i3].x > offsetMaxX) offsetMaxX = points[_i3].x;
                                    if (points[_i3].y > offsetMaxY) offsetMaxY = points[_i3].y;
                                }
                                offsetWidth = offsetMaxX - offsetMinX;
                                offsetHeight = offsetMaxY - offsetMinY;

                                offsetMinX -= imageX;
                                offsetMinY -= imageY;
                                base64 = clipCanvas.toDataURL();

                                clipContext.restore();
                                clipContext.clearRect(0, 0, operateWidth, operateHeight);
                                _context3.next = 33;
                                return this.selectComponent("#cp").clip({
                                    src: base64,
                                    x: offsetMinX * clipDpr,
                                    y: offsetMinY * clipDpr,
                                    width: offsetWidth * clipDpr,
                                    height: offsetHeight * clipDpr
                                });

                            case 33:
                                return _context3.abrupt('return', _context3.sent);

                            case 34:
                            case 'end':
                                return _context3.stop();
                        }
                    }
                }, _callee3, this);
            }));
        },

        /**
         * 旋转角度
         * @version 1.0.9
         * @param angle 角度
         */
        rotate: function rotate(angle) {
            return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee4() {
                var image, rr;
                return regeneratorRuntime.wrap(function _callee4$(_context4) {
                    while (1) {
                        switch (_context4.prev = _context4.next) {
                            case 0:
                                image = this.data.image;

                                this.data.imageAngle += angle;
                                _context4.next = 4;
                                return this.selectComponent("#rp").rotate({
                                    image: image,
                                    angle: angle
                                });

                            case 4:
                                rr = _context4.sent;
                                _context4.next = 7;
                                return this.imageChange(rr.tempFilePath);

                            case 7:
                                this.reset();
                                this.render();

                            case 9:
                            case 'end':
                                return _context4.stop();
                        }
                    }
                }, _callee4, this);
            }));
        },

        /**
         * @version 1.0.9 复位
         */
        reset: function reset() {
            var _data6 = this.data,
                image = _data6.image,
                imageX = _data6.imageX,
                imageY = _data6.imageY,
                imageWidth = _data6.imageWidth,
                imageHeight = _data6.imageHeight,
                clipCanvas = _data6.clipCanvas,
                clipContext = _data6.clipContext,
                points = _data6.points,
                pointRaduis = _data6.pointRaduis,
                allowTriangle = _data6.allowTriangle,
                operateWidth = _data6.operateWidth,
                operateHeight = _data6.operateHeight;

            points = [_ruToolkitMathematics.Vector2.c(imageX, imageY), _ruToolkitMathematics.Vector2.c(imageX + imageWidth, imageY), _ruToolkitMathematics.Vector2.c(imageX + imageWidth, imageY + imageHeight), _ruToolkitMathematics.Vector2.c(imageX, imageY + imageHeight)];
            this.data.points = points;
            this.render();
        }
    },
    observers: {
        "src": function src(newValue) {
            var _a;
            return __awaiter(this, void 0, void 0, /*#__PURE__*/regeneratorRuntime.mark(function _callee5() {
                var _data7, image, operateCanvas, src;

                return regeneratorRuntime.wrap(function _callee5$(_context5) {
                    while (1) {
                        switch (_context5.prev = _context5.next) {
                            case 0:
                                _data7 = this.data, image = _data7.image, operateCanvas = _data7.operateCanvas;
                                src = (_a = image) === null || _a === void 0 ? void 0 : _a.src;

                                if (!(operateCanvas != null && src != newValue)) {
                                    _context5.next = 7;
                                    break;
                                }

                                _context5.next = 5;
                                return this.imageChange(newValue);

                            case 5:
                                this.reset();
                                this.render();

                            case 7:
                            case 'end':
                                return _context5.stop();
                        }
                    }
                }, _callee5, this);
            }));
        }
    }
});

/***/ })
/******/ ]);
//# sourceMappingURL=index.js.map