module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 1);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports) {

module.exports = require("ru-toolkit-mathematics");

/***/ }),
/* 1 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";


exports.__esModule = true;
exports.errConfig = undefined;

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.scaling = scaling;
exports.timestamp = timestamp;
exports.sort = sort;
exports.base64ToTempFilePath = base64ToTempFilePath;
exports.triangle = triangle;
exports.createImage = createImage;
exports.maximumSizeOfCanvas = maximumSizeOfCanvas;

var _ruToolkitMathematics = __webpack_require__(0);

var errConfig = exports.errConfig = {
    NotAllowTriangle: { errCode: 1001, errMsg: "不允许三角形裁切" }
};
/**
 * 缩放
 * @param ow 源图宽
 * @param oh 源图高
 * @param tw 目标宽
 * @param th 目标高
 */
function scaling(ow, oh, tw, th) {
    var s = 0;
    if (ow > oh) {
        s = ow / oh;
        ow = tw;
        oh = ow / s;
    } else {
        s = ow / oh;
        oh = th;
        ow = oh * s;
    }
    if (th < oh) {
        s = ow / oh;
        oh = th;
        ow = oh * s;
    }
    if (tw < ow) {
        s = ow / oh;
        ow = tw;
        oh = ow / s;
    }
    return { ow: ow, oh: oh };
}
/**
 * 获取时间戳
 */
function timestamp() {
    return new Date().getTime();
}
/**
 * 点排序
 * @param points
 */
function sort(points) {
    var a = points[0];
    var b = points[1];
    var c = points[2];
    var d = points[3];
    if (_ruToolkitMathematics.Vector2.checkCross(a, b, c, d)) {
        b = points[2];
        c = points[1];
    } else if (_ruToolkitMathematics.Vector2.checkCross(a, d, c, b)) {
        a = points[1];
        b = points[0];
    }
    return [a, b, c, d];
}
/**
 * 获取临时图片
 * @param base64
 * @returns
 */
function base64ToTempFilePath(base64) {
    return new Promise(function (resolve, reject) {
        var fs = wx.getFileSystemManager();
        var times = new Date().getTime();
        var tempFilePath = wx.env.USER_DATA_PATH + '/' + times + '.png';
        fs.writeFile({
            filePath: tempFilePath,
            data: base64.split(',')[1],
            encoding: 'base64',
            success: function success(res) {
                resolve(tempFilePath);
            },
            fail: function fail(err) {
                reject(err);
            }
        });
    });
}
/** 三角形 */
function triangle(points) {
    var _loop = function _loop(i) {
        var curr = points[i];
        var other = points.filter(function (p, j) {
            return i != j;
        });
        if (_ruToolkitMathematics.Vector2.checkInTriangle(curr, other[0], other[1], other[2])) {
            return {
                v: other
            };
        }
    };

    for (var i = 0; i < points.length; i++) {
        var _ret = _loop(i);

        if ((typeof _ret === 'undefined' ? 'undefined' : _typeof(_ret)) === "object") return _ret.v;
    }
    return [];
}
/** 获取图片 */
function createImage(canvas, src) {
    return new Promise(function (resolve, reject) {
        var img = canvas.createImage();
        img.src = src;
        img.onload = function () {
            resolve(img);
        };
    });
}
/**
 * canvas最大尺寸
 * @param {HTMLCanvasElement} canvas
 * @param {number} width
 * @param {number} height
 * @param {number} dpr
 */
function maximumSizeOfCanvas(canvas, width, height, dpr) {
    var scale = 0;
    var targetWidth = 4096;
    var targetHeight = 4096;
    var currWidth = width;
    var currHeight = height;
    width *= dpr;
    height *= dpr;
    if (width < targetWidth && height < targetHeight) {
        canvas.width = width;
        canvas.height = height;
        return { width: width, height: height, dpr: dpr, canvas: canvas };
    }
    if (width > height) {
        scale = width / height;
        width = targetWidth;
        height = width / scale;
    } else {
        scale = width / height;
        height = targetHeight;
        width = height * scale;
    }
    if (targetHeight < height) {
        scale = width / height;
        height = targetHeight;
        width = height * scale;
    }
    if (targetWidth < width) {
        scale = width / height;
        width = targetWidth;
        height = width / scale;
    }
    canvas.width = width;
    canvas.height = height;
    return { width: width, height: height, canvas: canvas, dpr: width / currWidth };
}

/***/ })
/******/ ]);
//# sourceMappingURL=utils.js.map